<?php
/*
Plugin Name: SlideShare
Plugin URI: http://yoast.com/wordpress/slideshare/
Description: A plugin WordPress to easily display slideshare.net presentations
Version: 1.2
Author: Joost de Valk
Author URI: http://yoast.com/
*/

if ( ! class_exists( 'SlideShare_Admin' ) ) {

	class SlideShare_Admin {

		function add_config_page() {
			global $wpdb;
			if ( function_exists('add_submenu_page') ) {
				add_options_page('SlideShare Config', 'SlideShare', 10, basename(__FILE__),array('SlideShare_Admin','config_page'));
			}
		}
		
		function config_page() {
			if ( isset($_POST['submit']) ) {
				if (!current_user_can('manage_options')) die(__('You cannot edit the SlideShare options.'));
				check_admin_referer('slideshare-updatesettings');

				if (isset($_POST['slidesharepostwidth'])) {
					$options['postwidth'] = $_POST['slidesharepostwidth'];
				}
				
				update_option('SlideShare', $options);
			}

			$options  = get_option('SlideShare');
			?>
			<div class="wrap">
				<h2>SlideShare Configuration</h2>
				<form action="" method="post" id="slideshare-conf">
					<?php if (function_exists('wp_nonce_field')) { wp_nonce_field('slideshare-updatesettings'); } ?>
					<table class="form-table">
						<tr>
							<td>
								<label for="slidesharepostwidth">Default width:</label>
							</td>
							<td>
								<input size="5" type="text" id="slidesharepostwidth" name="slidesharepostwidth" value="<?php echo $options['postwidth'];?>"/> pixels
							</td>
						</tr>
						<tr>
							<td>&nbsp;</td>
							<td>
								<span class="submit"><input type="submit" name="submit" value="Update Settings &raquo;" /></span>
							</td>
					</table>
				</form>
				<h3>Explanation of usage</h3>
				<p>
					Just copy and paste the "Embed (wordpress.com)" code from <a href="http://www.slideshare.net/" title="SlideShare (share powerpoint presentations online, slideshows, slide shows, download presentations, widgets, MySpace codes)">SlideShare</a>, and you're done.
				</p>
				<h3>Explanation of default width</h3>
				<p>
					If you enter nothing here, you can change the width by hand by changing the w= value, that is bolded and red here:
				</p>
				<pre>[slideshare id=1234&amp;doc=how-to-change-the-width-123456789-1&amp;<strong style="color:red;">w=425</strong>]</pre>
				<p>
					If you <em>do</em> enter a value, it will always replace the width with that value.
				</p>
			</div>
			<?php
		}
	}
}

function slideshare_insert($atts, $content=null) {	
	$options = get_option('SlideShare');
	
	if(isset($atts)) {
		$args			= str_replace('&amp;','&',$atts['id']);
		$r 				= wp_parse_args($args);
	
		if ($options['postwidth'] == '') {
			$width		= $r['w'];			
		} else {
			$width		= $options['postwidth'];
		}
		$height			= $width / 1.22;
		
		$content	 	= '<object type="application/x-shockwave-flash" data="https://s3.amazonaws.com:443/slideshare/ssplayer.swf?id='.$r['id']
						.'&doc='.$r['doc'].'" '.'width="'.$width.'" '.'height="'.$height.'">'
						.'<param name="movie" value="https://s3.amazonaws.com:443/slideshare/ssplayer.swf?id='
						.$r['id'].'&doc='.$r['doc'].'"/></object>';
	}
	
	return $content;
}

add_action('admin_menu', array('SlideShare_Admin','add_config_page'));
add_shortcode('slideshare', 'slideshare_insert');

?>
